# Generated by Django 2.2 on 2019-09-27 09:23

import datetime
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import gestion_de_la_diffusion.fields


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Diffusable',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('titre', models.CharField(max_length=255)),
                ('date_publication', models.DateField(help_text='(Renseigne le champ TYER dans le Tag ID3v2 du fichier audio).', verbose_name='date de publication')),
                ('_duree', models.DurationField(default=datetime.timedelta(0), editable=False, verbose_name='durée')),
            ],
            options={
                'ordering': ['titre'],
            },
        ),
        migrations.CreateModel(
            name='Editeur',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('nom', models.CharField(help_text="Nom de l'éditeur (Renseignera le champ TPUB dans le Tag ID3v2 du fichier audio).", max_length=255, unique=True)),
                ('url', models.URLField(help_text="Adresse web du site de l'éditeur. Doit être une adresse web valide (Renseignera le champ WPUB dans le Tag ID3v2 du fichier audio).", verbose_name='site officiel')),
            ],
            options={
                'verbose_name': 'éditeur',
            },
        ),
        migrations.CreateModel(
            name='Frequence',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('nom', models.CharField(max_length=50, unique=True)),
                ('delta', models.DurationField(help_text="Le format est 'j hh:mm:ss'", unique=True, verbose_name='durée entre deux occurrences')),
            ],
        ),
        migrations.CreateModel(
            name='Licence',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('acronyme', models.CharField(help_text='Abréviation de la licence.', max_length=50, unique=True)),
                ('nom', models.CharField(help_text='Nom complet de la licence.', max_length=255, unique=True)),
                ('url', models.URLField(blank=True, help_text='(Facultatif) Site Internet du créateur de la licence (Renseignera le champ WCOP dans le Tag ID3v2 du fichier audio).', verbose_name='lien Internet')),
                ('texte', models.TextField(help_text='Texte complet de la licence.', verbose_name='définition de la licence')),
            ],
            options={
                'ordering': ['acronyme'],
            },
        ),
        migrations.CreateModel(
            name='Medium',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('nom', models.CharField(help_text="Type de medium permettant de qualifier la provenance d'un objet sonore.", max_length=500, unique=True)),
            ],
        ),
        migrations.CreateModel(
            name='ObjetSonore',
            fields=[
                ('objet_sonore_id', models.AutoField(primary_key=True, serialize=False)),
                ('fichier', gestion_de_la_diffusion.fields.SoundField(help_text="Formats de fichiers autorisés : 'Free Lossless Audio Codec (.flac)', 'MPEG-1 Audio Layer III (.mp3)', 'MPEG-1 Audio Layer II (.mp2)', 'Waveform Audio File Format (.wav)', 'Ogg Vorbis (.ogg)', 'Audio Interchange File Format (.aiff)', 'Sun Au (.au)', 'Advanced Audio Coding (.m4a)', 'Apple Lossless (.alac)', 'WavPack (.wv)', 'Opus Audio Codec (.opus)', 'True Audio (.tta)'.", max_length=500, upload_to='uploads', verbose_name='fichier sonore')),
            ],
        ),
        migrations.CreateModel(
            name='Provenance',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('description', models.CharField(blank=True, help_text='Un des deux champs (description ou lien Internet) doit être renseigné.', max_length=500, null=True)),
                ('url', models.URLField(blank=True, help_text='À renseigner obligatoirement pour les media Internet ou Production interne.', null=True, verbose_name='lien Internet')),
                ('medium', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='gestion_de_la_diffusion.Medium')),
            ],
        ),
        migrations.CreateModel(
            name='Programmation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('debut', models.DateTimeField(help_text='Date et heure du début de la programmation. Ne peut pas être créée dans le passé.', verbose_name='début')),
                ('fin', models.DateTimeField(help_text='Date et heure limite du début de la dernière occurrence de la programmation.')),
                ('date_creation', models.DateTimeField(auto_now_add=True, verbose_name='date de création')),
                ('date_modification', models.DateTimeField(auto_now=True, verbose_name='date de modification')),
                ('diffusable', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='gestion_de_la_diffusion.Diffusable')),
                ('frequence', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='gestion_de_la_diffusion.Frequence', verbose_name='fréquence')),
                ('programmateur', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='Ordonner',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('position', models.PositiveIntegerField(help_text='Position du diffusable dans la liste de lecture. Les positions doivent être toutes différentes dans une même liste de lecture.')),
                ('diffusable', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='ordonner_set_diffusable', to='gestion_de_la_diffusion.Diffusable', verbose_name='diffusable')),
            ],
            options={
                'verbose_name': 'contenu',
            },
        ),
        migrations.AddField(
            model_name='diffusable',
            name='editeur',
            field=models.ForeignKey(help_text='(Renseigne le champ TPUB ou WPUB dans le Tag ID3v2 du fichier audio).', on_delete=django.db.models.deletion.PROTECT, to='gestion_de_la_diffusion.Editeur', verbose_name='éditeur'),
        ),
        migrations.AddField(
            model_name='diffusable',
            name='licence',
            field=models.ForeignKey(default=6, help_text='(Renseigne le champ WCOP dans le Tag ID3v2 du fichier audio).', on_delete=django.db.models.deletion.PROTECT, to='gestion_de_la_diffusion.Licence'),
        ),
        migrations.CreateModel(
            name='Playlist',
            fields=[
                ('diffusable_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='gestion_de_la_diffusion.Diffusable')),
                ('description', models.TextField(help_text='Description du contenu de la liste de lecture.')),
                ('liste', models.ManyToManyField(help_text='Pistes ou épisodes faisant partie de cette liste de lecture.', related_name='playlist_set_liste', through='gestion_de_la_diffusion.Ordonner', to='gestion_de_la_diffusion.Diffusable')),
            ],
            options={
                'verbose_name': 'liste de lecture',
                'verbose_name_plural': 'listes de lecture',
            },
            bases=('gestion_de_la_diffusion.diffusable',),
        ),
        migrations.AddField(
            model_name='ordonner',
            name='playlist',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='ordonner_set_playlist', to='gestion_de_la_diffusion.Playlist', verbose_name='liste de lecture'),
        ),
        migrations.AlterUniqueTogether(
            name='ordonner',
            unique_together={('playlist', 'position')},
        ),
    ]
